moDraw.slots = {};

--new test script all slots !!!
function moDraw.slots:setOpenPDA(self, slotType)	
	local slotOpen = moGuiMiniPDAsetGet.slotOpen;
	local tableType;
	local tableFoundType;
	local foundObjects = 0;
	local lengthFillName = 13;		
	if slotType == "placeableTrees" then tableFoundType = moDefaultPlaceable.treesFound;tableType = moPlaceableTrees;foundObjects = moDefaultPlaceable.lengthTrees;lengthFillName = moDefault.lengthTreesFillName;end;
	if slotType == "placeableMods" then tableFoundType = moDefaultPlaceable.modsFound;tableType = moPlaceableMods;foundObjects = moDefaultPlaceable.lengthMods;lengthFillName = moDefault.lengthModsFillName;end;
	if tonumber(foundObjects) == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['slotTypeNO'.. moDefault.language]).. "(".. slotType.. ")", 2500);
		return;
	end;
	--if slotType == "placeableObjects" then tableFoundType = moDefaultPlaceable.objectsFound;tableType = moPlaceableObjects;end;
	--if slotType == "greenHouse" then tableFoundType = moDefaultPlaceable.greenHouseFound;tableType = moPlaceableGreenHouse;end;
	--if moDefaultPlaceable.lengthTrees == 0 then
	--	moGuiMiniPDAsetGet.slotOpen = 0;
	--	g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['placeableTreeNO'.. moDefault.language]), 2500);
	--	return;
	--end;
	--local foundObjects = moGuiMiniPDAsetGet.foundObjects[slotOpen];	
	local openSwitchStatus = moGuiMiniPDAsetGet.slotSwitch[slotOpen];
	local maxProSwitch = moGuiMiniPDAsetGet.maxProSwitch[slotOpen];
	local pdaMenueSize = moSetGetGui.pdaMenueSize;
	setTextBold(true);
	setTextAlignment(false);
	local fixDifferenz = 0.007+pdaMenueSize/2;
	local posB = pdaMenueSize/3*(moGuiMiniPDAsetGet.lengthDefault[slotOpen]+lengthFillName+moSetGetGui.screenAspectRatio)*1.03;
	local posX = moGuiMiniPDAsetGet.slotOpenX[slotOpen]+(pdaMenueSize*2/1.8);
	if moGuiMiniPDAsetGet.slotOpenX[slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[slotOpen]+(pdaMenueSize*2/1.8)-posB;end;
	local posY = moGuiMiniPDAsetGet.slotOpenY[slotOpen];
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(pdaMenueSize/1.17);
	local firstPosXYsave = posY-(pdaMenueSize/1.17);
	local firstLetter = 0.003;
	local lengthAllObjects = 0;
	function nextLine(posNew, setLine, halfLine)
		if setLine then
			if halfLine then
				moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, (posB-fixDifferenz)/4, 0.001);
			else
				moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posB-fixDifferenz, 0.001);
			end;
			moSetGetGui["designLine"]:render();
		end;
		if posNew == 0 then return;end;
		firstPosXY = firstPosXY-(pdaMenueSize+posNew);
		posH = posH+pdaMenueSize+posNew;
		posY = posY-(pdaMenueSize+posNew);
	end;					
	moSetGetGui["designGround"]:render();	
	setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
	if tonumber(foundObjects) > tonumber(maxProSwitch) then
		renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, "!Objecte!:");
	else
		renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, "Objecte:");
	end;	
	--setTextAlignment(RenderText.ALIGN_RIGHT);
	--setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));	
	--renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(foundObjects));
	--setTextAlignment(false);					
	nextLine(0.005, true);
	function setDrawFillTypes(tableName, tableFillTypes, input, stock, heaps, shop, trees)		
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		local fillTypeName = "";
		local toLongFillTypeName = "";
		if tableFillTypes.lengthFillTypes > 1 then			
			fillTypeName = unpack(moLanguage.extern['fillcontainer'.. moDefault.language]);			
			local stringLength = 0.010/3*(string.len(tableFillTypes.fillTypeName))*1.03;
			if posB >= stringLength then								
				fillTypeName = tostring(tableFillTypes.fillTypeName);
			else
				local splitNames = Utils.splitString(" ", tableFillTypes.fillTypeName)
				toLongFillTypeName = "too long(".. (table.getn(splitNames)-1).. " fruit names)";
			end;			
		else
			if string.find(tableFillTypes.fillTypeName, "!") then setTextColor(unpack(moGuiMiniPDAsetGet.warningColor4));end;
			fillTypeName = tostring(tableFillTypes.fillTypeName);
			--renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(tableFillTypes.fillTypeName));
			--renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['capacity'.. moDefault.language]));
		end;
		if heaps and Utils.getNoNil(tableFillTypes.fillLevel, 0) < 0.1 then setTextColor(unpack(moGuiMiniPDAsetGet.warningColor2));end;				
		renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(fillTypeName));				
		setTextAlignment(RenderText.ALIGN_RIGHT);					
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		local capacity = string.format("%1.0f", Utils.getNoNil(tableFillTypes.capacity, 0));
		local fillLevel = string.format("%1.0f", Utils.getNoNil(tableFillTypes.fillLevel, 0));
		if heaps then capacity = "";end;		
		if not shop then
			renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");			
		else
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
			local bestPriceTemp = string.format("%.1f", Utils.getNoNil(tableFillTypes.bestPrice, 0));
			renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(bestPriceTemp).. " €");
		end;
		setTextAlignment(false);
		if string.len(toLongFillTypeName) > 0 then
			nextLine(0.0015);
			setTextBold(false);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
			renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, 0.010, tostring(toLongFillTypeName));
		end;
		if trees then
			if tableName.lengthActive > 0 then
				nextLine(0.0015);
				setTextBold(false);
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['treesActive'.. moDefault.language]));
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
				renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(tableName.lengthActive));
				setTextAlignment(false);
			end;
			if tableName.lengthNotActive > 0 then
				nextLine(0.0015);
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, 0.010, unpack(moLanguage.extern['treesNotActive'.. moDefault.language]));
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
				renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(tableName.lengthNotActive));
				setTextAlignment(false);
			end;
		end;
	end;
	local foundFirstHeap = false;
	function setObjectsDisplay(v)
		lengthAllObjects = lengthAllObjects+tableType[v].length;	
		local stock = false;
		local heaps = false;
		local shop = false;
		local trees = false;
		setTextBold(true);		
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
		renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tableType[v].displayName.. "(".. tostring(tableType[v].modType).. ")");
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(tableType[v].length));
		setTextAlignment(false);
		nextLine(0.0025);
		setTextBold(false);
		if tableType[v].category == "stock" then stock = true;end;
		if tableType[v].category == "heaps" then heaps = true;foundFirstHeap = true;end;
		if tableType[v].category == "shop" then shop = true;end;
		if tableType[v].category == "trees" then trees = true;end;
		if not stock and not heaps and not shop then
			setTextColor(unpack(tableType[v].productivityColor));
			renderText(posX+(firstLetter)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, unpack(moLanguage.extern['productivity'.. moDefault.language]));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXY, pdaMenueSize, tostring(tableType[v].productivity).. "%");
			setTextAlignment(false);
			nextLine(0.0025);
		end;
		local foundOutputFillTypes = false;			
		if not shop and not heaps and tableType[v].outputFillTypes ~= nil and table.getn(tableType[v].outputFillTypes) > 0 then
			for container=1, table.getn(tableType[v].outputFillTypes) do
				foundOutputFillTypes = true;					
				setDrawFillTypes(tableType[v], tableType[v].outputFillTypes[container], false, stock, heaps, shop, trees);
				if container < table.getn(tableType[v].outputFillTypes) then nextLine(0.0025);end;
			end;
		end;			
		if not stock and tableType[v].inputFillTypes ~= nil and table.getn(tableType[v].inputFillTypes) > 0 then
			if foundOutputFillTypes then nextLine(0.007, true, true);end;
			for container=1, table.getn(tableType[v].inputFillTypes) do
				setDrawFillTypes(tableType[v], tableType[v].inputFillTypes[container], true, stock, heaps, shop, trees);
				if container < table.getn(tableType[v].inputFillTypes) then nextLine(0.0025);end;
			end;
		end;		
	end;
	function getObjectsLength()
		if foundObjects > maxProSwitch and tonumber(openSwitchStatus) == 2 then return maxProSwitch+1, maxProSwitch*2;end;
		if foundObjects > maxProSwitch*2 and tonumber(openSwitchStatus) == 3 then return maxProSwitch*2+1, maxProSwitch*3;end;
		if foundObjects > maxProSwitch*3 and tonumber(openSwitchStatus) == 4 then return maxProSwitch*3+1, maxProSwitch*4;end;
		if foundObjects > maxProSwitch*4 and tonumber(openSwitchStatus) == 5 then return maxProSwitch*4+1, maxProSwitch*5;end;
		if foundObjects > maxProSwitch*5 and tonumber(openSwitchStatus) == 6 then return maxProSwitch*5+1, maxProSwitch*6;end;
		if foundObjects > maxProSwitch*6 and tonumber(openSwitchStatus) == 7 then return maxProSwitch*6+1, maxProSwitch*7;end;
		if foundObjects > maxProSwitch*7 and tonumber(openSwitchStatus) == 8 then return maxProSwitch*7+1, maxProSwitch*8;end;
		return 1, maxProSwitch;
	end;
	local firstObjectsDisplay, maxObjectsDisplay = getObjectsLength();
	local saveTempFirstObjectsDisplay = firstObjectsDisplay;
	local tempObjectsDisplay = 0;
	local splitFound = Utils.splitString(" ", tableFoundType)
	for k, v in pairs (splitFound) do		
		if string.len(v) > 1 and v ~= nil and tableType[v] ~= nil then			
			tempObjectsDisplay = tempObjectsDisplay+1;
			if tonumber(tempObjectsDisplay) >= tonumber(firstObjectsDisplay) then					
				if tonumber(firstObjectsDisplay) > tonumber(maxObjectsDisplay) then break;end;
				firstObjectsDisplay = firstObjectsDisplay+1;
				setObjectsDisplay(v);
				if tonumber(k) == table.getn(splitFound) then nextLine(0.0025, true);end;
				if tonumber(k) < table.getn(splitFound) then nextLine(0.005, true);end;
			end;			
		end;
	end;
	---gesamt
	setTextBold(true);
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
	if tonumber(foundObjects) > tonumber(maxProSwitch) then
		--local stringLength = string.len(tostring(saveTempFirstObjectsDisplay).. "-".. tostring(maxObjectsDisplay).. "(".. tostring(foundObjects).. ")")/45
		--renderText(posX+(stringLength)-(pdaMenueSize/5), firstPosXYsave, pdaMenueSize, tostring(saveTempFirstObjectsDisplay).. "-".. tostring(maxObjectsDisplay).. "(".. tostring(foundObjects).. ")");
		renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXYsave, pdaMenueSize, tostring(saveTempFirstObjectsDisplay).. "-".. tostring(maxObjectsDisplay).. "(".. tostring(foundObjects).. ")");
	else
		renderText(posX+(posB/1.17)-(pdaMenueSize/5), firstPosXYsave, pdaMenueSize, tostring(foundObjects));
	end;	
	setTextAlignment(false);
	---gesamt
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.003, posY, posB-fixDifferenz+0.003, posH);
	moGuiMiniPDAsetGet.slotOpenLastWidth[slotOpen] = posB-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[slotOpen] = posH;	
	setTextBold(false);	
end;