moDraw.greenHouse = {};

function moDraw.greenHouse:setOpenPDA(self)	
	if moDefaultPlaceable.lengthGreenHouse == 0 then --and moDefaultPlaceable.lengthGreenHouse == 0 and moDefaultPlaceableObjects.lengthGreenHouse == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['greenHouseNO'.. moDefault.language]), 2500);
		return;
	end;	
	local openSwitchStatus = moGuiMiniPDAsetGet.slotSwitch[moGuiMiniPDAsetGet.slotOpen];
	setTextBold(true);
	local fixDifferenz = 0.007+moSetGetGui.pdaMenueSize/2;
	local posBGreenHouse = moSetGetGui.pdaMenueSize/3*(30+moDefault.lengthGreenHouseFillName+moSetGetGui.screenAspectRatio)*1.03;
	local posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8);
	if moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-posBGreenHouse;end;
	local posY = moGuiMiniPDAsetGet.slotOpenY[moGuiMiniPDAsetGet.slotOpen];
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(moSetGetGui.pdaMenueSize/1.17);
	local firstPosXYsave = posY-(moSetGetGui.pdaMenueSize/1.17);
	local lengthAllGreenHouse = 0;
	local firstLetter = 0.003;
	function nextLine(posNew, setLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posBGreenHouse-fixDifferenz, 0.001);
			moSetGetGui["designLine"]:render();
		end;
		firstPosXY = firstPosXY-(moSetGetGui.pdaMenueSize+posNew);
		posH = posH+moSetGetGui.pdaMenueSize+posNew;
		posY = posY-(moSetGetGui.pdaMenueSize+posNew);
	end;					
	moSetGetGui["designGround"]:render();
	setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
	if moDefaultPlaceable.lengthGreenHouse > 5 then
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['greenHouse'.. moDefault.language]).. "(!switch!)");
	else
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['greenHouse'.. moDefault.language]));
	end;
	nextLine(0.005, true);	
	function sortUpkFillType(v, a, sortUpk)
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].fillTypeName[a]));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].capacity[a]).. " (".. tostring(moGreenHouse[v].fillLevel[a]).. ")L");				
		setTextAlignment(false);
		if not sortUpk and moGreenHouse[v].bestPrice[a] > 0 then
			nextLine(0.00125);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['price'.. moDefault.language]));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			local bestPriceTemp = string.format("%.1f", Utils.getNoNil(moGreenHouse[v].bestPrice[a], 0));
			renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(bestPriceTemp).. " €");
			setTextAlignment(false);
			--if table.getn(moGreenHouse[v].capacity) ~= tonumber(a) then nextLine(0.0025);end;
		else
			--if table.getn(moGreenHouse[v].capacity) ~= tonumber(a) then nextLine(0.0025);end;
		end;
		nextLine(0.0025);
	end;
	local marker = "";	
	function setGreenHouseDisplay(v)
		lengthAllGreenHouse = lengthAllGreenHouse+moGreenHouse[v].length;
		setTextBold(true);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].greenHouseName).. "(".. tostring(moGreenHouse[v].modType).. ")");
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].length));				
		setTextAlignment(false);
		nextLine(0.0025);
		setTextBold(false);
		setTextColor(unpack(moGreenHouse[v].productivityColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['productivity'.. moDefault.language]));
		setTextAlignment(RenderText.ALIGN_RIGHT);				
		renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].productivity).. "%");	
		setTextAlignment(false);
		if tostring(moGreenHouse[v].modType) == "ls" then				
			nextLine(0.005);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['greenHouseManure'.. moDefault.language])));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].capacityManure).. " (".. tostring(moGreenHouse[v].fillLevelManure).. ")L");	
			setTextAlignment(false);
			nextLine(0.0025);
			setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
			renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(unpack(moLanguage.extern['greenHouseWater'.. moDefault.language])));
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
			renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].capacityWater).. " (".. tostring(moGreenHouse[v].fillLevelWater).. ")L");	
			setTextAlignment(false);
			nextLine(0.005, true);
		end;
		if tostring(moGreenHouse[v].modType) == "fs" then
			nextLine(0.0025);					
			for a=1, table.getn(moGreenHouse[v].capacity) do
				local capacity = string.format("%0.0f", Utils.getNoNil(moGreenHouse[v].capacity[a], 0));
				local fillLevel = string.format("%0.0f", Utils.getNoNil(moGreenHouse[v].fillLevel[a], 0));
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				--local fillNameSplit = nil;
				--if string.find(tostring(moGreenHouse[v].fillTypeName[a]), "(", 0, true) then
				--	local splitName = Utils.splitString("(", moGreenHouse[v].fillTypeName[a])
				--	if splitName ~= nil and splitName[1] ~= nil and splitName[2] ~= nil then
				--		fillNameSplit = splitName;						
				--	end;
				--end;
				if not moGreenHouse[v].fillType[a] then						
					--if fillNameSplit ~= nil then
						--renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(fillNameSplit[1]));
						--nextLine(0.0025);
						--renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "(".. tostring(fillNameSplit[2]));
					--else
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].fillTypeName[a]));
					--end;						
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
					renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");
					setTextAlignment(false);
					nextLine(0.0025);
				else
					nextLine(0.0025);
					setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					--if fillNameSplit ~= nil then
					--	renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(fillNameSplit[1]));
						--nextLine(0.0025);
						--renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "(".. tostring(fillNameSplit[2]));
					--else
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moGreenHouse[v].fillTypeName[a]));
					--end;							
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));						
					renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");	
					setTextAlignment(false);							
				end;												
			end;								
			nextLine(0.005, true);
		end;
		if tostring(moGreenHouse[v].modType) == "upk" then
			nextLine(0.0025);
			for a=1, table.getn(moGreenHouse[v].capacity) do
				if not moGreenHouse[v].fillType[a] then
					sortUpkFillType(v, a, false);						
				else
					marker = marker.. tostring(a).. " ";
				end;					
			end;
			nextLine(0.0025);
			local splitMarker = Utils.splitString(" ", marker)
			for k1, v1 in pairs (splitMarker) do
				if string.len(tostring(v1)) > 0 and v1 ~= nil and not string.find(tostring(v1), " ") then
					sortUpkFillType(v, tonumber(v1), true);
				end;
			end;
			marker = "";
			nextLine(0.005, true);
		end;
	end;
	function getGreenHouseLength()
		if moDefaultPlaceable.lengthGreenHouse > 5 and tonumber(openSwitchStatus) == 2 then return 6, 10;end;
		if moDefaultPlaceable.lengthGreenHouse > 10 and tonumber(openSwitchStatus) == 3 then return 11, 15;end;		
		return 1, 5;
	end;
	local firstGreenHouseDisplay, maxGreenHouseDisplay = getGreenHouseLength();
	local tempGreenHouseDisplay = 0;
	if moDefaultPlaceable.lengthGreenHouse > 0 then
		local splitGreenHouse = Utils.splitString(" ", moDefaultPlaceable.greenHouseFound)
		for k, v in pairs (splitGreenHouse) do
			if string.len(v) > 1 and v ~= nil and moGreenHouse[v] ~= nil then				
				tempGreenHouseDisplay = tempGreenHouseDisplay+1;
				if tonumber(tempGreenHouseDisplay) >= tonumber(firstGreenHouseDisplay) then					
					if tonumber(firstGreenHouseDisplay) > tonumber(maxGreenHouseDisplay) then break;end;
					firstGreenHouseDisplay = firstGreenHouseDisplay+1;
					setGreenHouseDisplay(v);
				end;				
			end;
		end;
	end;	
	---gesamt
	setTextBold(true);
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
	renderText(posX+(posBGreenHouse/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXYsave, moSetGetGui.pdaMenueSize, tostring(lengthAllGreenHouse));	
	setTextAlignment(false);
	---gesamt		
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.003, posY, posBGreenHouse-fixDifferenz+0.003, posH);
	moGuiMiniPDAsetGet.slotOpenLastWidth[moGuiMiniPDAsetGet.slotOpen] = posBGreenHouse-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[moGuiMiniPDAsetGet.slotOpen] = posH;	
	setTextBold(false);	
end;